#ifndef __BATANIMATION
#define __BATANIMATION

#include "BList.h"
#include "GLTile.h"
#include "GLTManager.h"

class BatAnimation {
public:
	float x,y;
	float speed_x,speed_y;
	float t;
	float speed_t;
	float scale;
};


class BatEffect {
public:
	virtual ~BatEffect()  {
	}

	virtual bool cycle() = 0;
	virtual void draw() = 0;

private:
};

class BatEffectA : public BatEffect {
public:
	BatEffectA(int n,float r,float g,float b,float min_speed,float max_speed,int length,GLTManager *GLTM);
	virtual ~BatEffectA() {
	};

	virtual bool cycle() ;
	virtual void draw();

private:
	int m_cycle,m_length;
	GLTManager *m_GLTM;
	float m_r,m_g,m_b;
	GLTile *m_ba1,*m_ba2,*m_ba3;
	List<BatAnimation> m_bat_animations;

};


class BatEffectB : public BatEffect {
public:
	BatEffectB(int n,float r,float g,float b,float min_speed,float max_speed,int length,GLTManager *GLTM);
	virtual ~BatEffectB() {
	};

	virtual bool cycle();
	virtual void draw();

private:
	int m_cycle,m_length;
	GLTManager *m_GLTM;
	float m_r,m_g,m_b;
	GLTile *m_ba1,*m_ba2,*m_ba3;
	List<BatAnimation> m_bat_animations;

};

#endif
