/*
 *  KText.cpp
 *  Knightmare
 *
 *  Created by Santi Ontañón on 11/13/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */


#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif


#ifdef _WIN32
#include "windows.h"
#endif

#include "stdlib.h"
#include "string.h"
#include "math.h"

#include "debug.h"

#include "GL/gl.h"
#include "SDL.h"
#include "SDL_image.h"
#include "SDL_mixer.h"
#include "SDL_ttf.h"

#include "BList.h"

#include "auxiliar.h"
#include "2DCMC.h"
#include "Symbol.h"
#include "GLTile.h"
#include "keyboardstate.h"
#include "Binterface.h"

#include "GLTManager.h"
#include "SoundManager.h"
#include "SFXManager.h"
#include "KObject.h"
#include "KText.h"

#include "KObjectCreator.h"

KText::KText(int x, int y, char *text,TTF_Font *font,int duration) : KObject(x,y,0){
    m_class = ktext_symbol;
    m_last_tile_used = 0;
	m_timmer = duration;
	m_font = font;
	if (text!=0) {
		m_text = new char[strlen(text)+1];
		strcpy(m_text,text);
	} else {
		m_text = 0;
	}
}

KText::~KText() {
}

void KText::draw(float angle,GLTManager *GLTM)
{
	draw(angle,0,0,GLTM);
} // KText::draw 


void KText::draw(float angle,int x_offset,int y_offset,GLTManager *GLTM)
{
	float a = 1.0f;

	if (m_text!=0) {
		if (m_timmer<50) {
			a = float(m_timmer)/50.0f;
		}

		if (m_keep_angle && angle!=0) {
			glPushMatrix();
			glTranslatef(m_x+x_offset,m_y+y_offset,0);
			glRotatef(angle,1,0,0);
			Binterface::print_center(m_text,m_font,1,1,0,0,0,a);
			Binterface::print_center(m_text,m_font,0,0,1,1,1,a);
			glPopMatrix();
		} else {
			Binterface::print_center(m_text,m_font,m_x+x_offset+1,m_y+y_offset+1,0,0,0,a);
			Binterface::print_center(m_text,m_font,m_x+x_offset,m_y+y_offset,1,1,1,a);
		}
	}
} // KText::draw 


bool KText::cycle(List<VirtualController> *vcl, Knightmare *game, GLTManager *GLTM, SFXManager *SFXM)
{
	m_timmer--;
	if (m_timmer<=0) return false;
	return true;
}


bool KText::is_a(Symbol *c)
{
    if (c->cmp(ktext_symbol))
        return true;
	
    return KObject::is_a(c);
} /* KText::is_a */


bool KText::is_a(char *c)
{
    bool retval;
    Symbol *s = new Symbol(c);
	
    retval = is_a(s);
	
    delete s;
	
    return retval;
} /* KText::is_a */


